=== debian/changelog ===
strawberry (0.5.2-0.1~mx17+1) mx; urgency=medium

  * Initial packaging.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 03 Feb 2019 15:59:30 -0800
